/*
 * message.h
 *
 *  Created on: 14.09.2013
 *      Author: Claude
 */

struct message_t {
	uint8_t component_type;
	uint8_t component_subtype;
	uint8_t component_nr;
	uint8_t message_type;
	uint8_t message;
	uint8_t value_length;
	uint8_t checksum;
};

#ifndef MESSAGE_H_
#define MESSAGE_H_

#define MESSAGE_COMPONENT_TYPE_SYSTEM 0
#define MESSAGE_COMPONENT_TYPE_BUTTON 1
#define MESSAGE_COMPONENT_TYPE_POWER 2
#define MESSAGE_COMPONENT_TYPE_SENSOR 3
#define MESSAGE_COMPONENT_TYPE_CLOCK 4

#define MESSAGE_COMPONENT_SUBTYPE_SYSTEM_SYSTEM 0
#define MESSAGE_COMPONENT_SUBTYPE_SYSTEM_NETWORK 1
#define MESSAGE_COMPONENT_SUBTYPE_SYSTEM_ERROR 2
#define MESSAGE_COMPONENT_SUBTYPE_BUTTON_PUSH_BUTTON 0

#define MESSAGE_MESSAGE_TYPE_COMMAND 0
#define MESSAGE_MESSAGE_TYPE_EVENT 1
#define MESSAGE_MESSAGE_TYPE_STATUS 2

#define MESSAGE_MESSAGE_SYSTEM_SYSTEM_STOP 0
#define MESSAGE_MESSAGE_SYSTEM_SYSTEM_START 1
#define MESSAGE_MESSAGE_SYSTEM_SYSTEM_RESET 2
#define MESSAGE_MESSAGE_SYSTEM_SYSTEM_CANGE_DEVICE_ID 3
#define MESSAGE_MESSAGE_SYSTEM_SYSTEM_CANGE_DEVICE_NAME 4
#define MESSAGE_MESSAGE_SYSTEM_EVENT_STOP 0
#define MESSAGE_MESSAGE_SYSTEM_EVENT_START 1
#define MESSAGE_MESSAGE_SYSTEM_EVENT_RESET 2
#define MESSAGE_MESSAGE_SYSTEM_EVENT_DEVICE_ID_CHANGED 3
#define MESSAGE_MESSAGE_SYSTEM_EVENT_DEVICE_NAME_CHANGED 4
#define MESSAGE_MESSAGE_SYSTEM_STATUS_STOPPED 0
#define MESSAGE_MESSAGE_SYSTEM_STATUS_RUNNING 1
#define MESSAGE_MESSAGE_SYSTEM_STATUS_DEVICE_TYPE 2
#define MESSAGE_MESSAGE_SYSTEM_STATUS_DEVICE_SUBTYPE 3
#define MESSAGE_MESSAGE_SYSTEM_STATUS_VENDOR_ID 4
#define MESSAGE_MESSAGE_SYSTEM_STATUS_PRODUCT_ID 5
#define MESSAGE_MESSAGE_SYSTEM_STATUS_PRODUCT_NAME 6
#define MESSAGE_MESSAGE_SYSTEM_STATUS_HARDWARE_VERSION 7
#define MESSAGE_MESSAGE_SYSTEM_STATUS_SOFTWARE_VERSION 8
#define MESSAGE_MESSAGE_SYSTEM_STATUS_DEVICE_NAME 9

#define MESSAGE_MESSAGE_BUTTON_PUSH_BUTTON_EVENT_RELEASED 0
#define MESSAGE_MESSAGE_BUTTON_PUSH_BUTTON_EVENT_PRESSED 1
#define MESSAGE_MESSAGE_BUTTON_PUSH_BUTTON_STATUS_RELEASED 0
#define MESSAGE_MESSAGE_BUTTON_PUSH_BUTTON_STATUS_PRESSED 1

#endif /* MESSAGE_H_ */
